/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FREEBOOTER_BASE
#define FREEBOOTER_BASE
#include "ModelEntity.h"

class CBase :
	public CModelEntity
{
public:
	CBase(void);
	~CBase(void);

	// This states the name of the base
	string name;

	// This states the tech level of the base, which affects the availability of 
	// equipment/guns/shields and the cost of high-tech goods. Low tech level, high tech
	// goods are expensive. High tech level, high tech goods are relatively cheep.
	int techLevel_i;

	// These four values rate the relative production capabilities of a given base.
	// the higher these values are, the cheeper relevant goods will be at that base.
	// low values indicate the base's needs, the things it's hard to buy but which 
	// they'll certainly pay more for.
	int agriculture_i;		// food, animals etc...
	int rawMaterials_i;		// minerals, ores etc...
	int luxuryItems_i;		// entertainment goods, fluffy things...
	int fuel_i;				// can make travelling expensive if this is low.
	int refinedGoods_i;		// Tools, machinery, equipment, everyday materials...
	int techGoods_i;		// computer parts, complex machinery, expensive materials

	// anything else?

	void Update();
};

#endif
