/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FREEBOOTER_EQUIPMENT_DEF
#define FREEBOOTER_EQUIPMENT_DEF

// these define the equipment that can be found on a ship.
#define BOOST            0x01   // boosts top speed and acceleration for a short time
#define THRUST_UPGRADE_1 0x02	// increases top speed and acceleration
#define THRUST_UPGRADE_2 0x04	// ditto, but that bit more
#define THRUST_UPGRADE_3 0x08	// and again
#define ENGINE_UPGRADE   0x10	// improved engine increases mass that can be lifted.
#define SALVAGE_HOOK     0x20   // hook to tow salvage back to a base
#define INFIL_SCANNER    0x40   // scanner that reveals more data about a ship (weap, cargo)
#define SALVAGE_SCANNER  0x80   // scanner that reveals expected value of a salvage object


// these define cargo types
#define AGRIC   0
#define RAWMAT  1
#define LUXURY  2
#define FUEL    3
#define REFINED 4
#define TECH    5

#endif