/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FREEBOOTER_GALAXY
#define FREEBOOTER_GALAXY

#include "Scene.h"
#include "FreeBooter.h"

class CGalaxy :
	public CScene
{
public:
	CGalaxy(void);
	~CGalaxy(void);

	string filename_s;

	// dimensions of the galaxy
	float width_f;		// x
	float height_f;		// y

	// background texture - a bad way of doing this I'm sure ...
	int backTex_i;
	int starsTex_i;

	// types of gun available in the game
	CDynArray<SGunType*> gunTypes;

	// types of ship available in the game
	CDynArray<SShipType*> shipTypes;

	// types of cargo available in the game
	CDynArray<SCargoType*> cargoTypes;

	// factions in the galaxy. faction 0 is always generated, and is "independant"
	CDynArray<SFaction*> factions;

	// bases in the game
	CDynArray<int> bases;
	int AddBase(CBase *in_Base);

	// inerts (rocks/asteroids/derelicts)
	CDynArray<int> inerts;
	int AddInert(CInert *in_Inert);

	// ships
	CDynArray<int> ships;
	CDynArray<int> shipsAvailToPlayer;
	int AddShip(CShip *in_Ship);
	
	// particle generator for particles needing to not be in a ship's hierarchy
	CSimpleParticleGenerator galPartGen;

	// load from file
	int LoadFromFile(string in_Filename_s);
	// background scenery/images ???

	// redefine rendering function
	int Render();

	// and update function
	void Update();

	void FreeAll();
};
#endif
