/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FREEBOOTER_GALLOADER
#define FREEBOOTER_GALLOADER

#define CARGOT  0 
#define GUNT    1
#define SHIPT   2
#define WIDTH   3
#define HEIGHT  4
#define BASE    5
#define RBASE   6
#define RINERT  7
#define RSHIP   8
#define FACTION 9		// a faction
#define NUMFACT 10		// number of factions in galaxy
#define SHIP    11

#include "FreeBooter.h"

class CGalaxyLoader
{
public:
	CGalaxyLoader(void);
	~CGalaxyLoader(void);

	ifstream inFile;
	int Load(string in_Filename_s, CGalaxy *in_Galaxy);

protected:
	int ReadType();
	template <typename T> T ReadToken();
	CVec4f ReadPos();
	void NextLine();

};

template <typename T> 
T CGalaxyLoader::ReadToken()
{
	T out_T;
	inFile >> out_T;
	return out_T;
}

#endif
