/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Inert.h"
#include "Galaxy.h"

CInert::CInert(void)
{
}

CInert::~CInert(void)
{
}

void CInert::Update()
{
	pos_v4f = pos_v4f + vel_v4f;
	vel_v4f = vel_v4f * 0.99f;
	vel_v4f.SetW(0);

	// check for a collision with an inert
	extern CFreebooter FB;
	CGalaxy *gal = (CGalaxy*) FB.scene;

	if(vel_v4f.MagSquare() > 0.01)
	{
		
		for(int sc_i = 0; sc_i < gal->inerts.Size(); sc_i++)
		{

			if(gal->ents[gal->inerts[sc_i]] != this)
				if(this->BSBSCollision((CModelEntity*)gal->ents[gal->inerts[sc_i]]) == true)
				{
					CVec4f tempVel1;
					CVec4f tempVel2;
					tempVel1 = GetVelocity();
					tempVel2 = gal->ents[gal->inerts[sc_i]]->GetVelocity();

					tempVel1.SetW(0);
					tempVel2.SetW(0);

					CVec4f entEnt_v4f, negEntEnt;
					entEnt_v4f = gal->ents[gal->inerts[sc_i]]->GetPos() - pos_v4f;
					entEnt_v4f.SetW(0);
													
					CVec4f w;
					if(tempVel1.MagSquare() > 0.01)
					{
						//w = tempVel1 * ((tempVel1.Dot(entEnt_v4f)) / tempVel1.MagSquare());
						w = entEnt_v4f * ((tempVel1.Dot(entEnt_v4f)) / entEnt_v4f.MagSquare());
					}
					else w.SetXYZW(0,0,0,0);
					
					tempVel2 = tempVel2 + w;
					tempVel1 = tempVel1 - w;
					

					this->SetVelocity(tempVel1.X(), tempVel1.Y(), 0);
					gal->ents[gal->inerts[sc_i]]->SetVelocity(tempVel2.X(), tempVel2.Y(), 0);
				}
		}
	
	
		if((pos_v4f.X() > gal->width_f) && (vel_v4f.X() > 0)) vel_v4f.SetX(-vel_v4f.X());
		if((pos_v4f.X() < 0) && (vel_v4f.X() < 0)) vel_v4f.SetX(-vel_v4f.X());

		if((pos_v4f.Y() > gal->height_f) && (vel_v4f.Y() > 0)) vel_v4f.SetY(-vel_v4f.Y());
		if((pos_v4f.Y() < 0) && (vel_v4f.Y() < 0)) vel_v4f.SetY(-vel_v4f.Y());
	}
}
