/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FREEBOOTER_SHIPTYPELOADER
#define FREEBOOTER_SHIPTYPELOADER

#include <string>
#include <fstream>
#include "FreeBooter.h"
using namespace std;

#define NAME      0
#define MESH      1
#define TEXTURE   2
#define MASS      3
#define FWDACC    4
#define THRPOS    5
#define RVSACC    6
#define GUN       7
#define ROTSPD    8
#define MAXHEALTH 9
#define MAXCARMAS 10
#define MAXCARVOL 11
#define VALUE	  12

class CShipLoader
{
public:
	CShipLoader(void);
	~CShipLoader(void);

	ifstream inFile;
	int Load(string in_Filename_s, CGalaxy *in_Galaxy);

protected:
	int ReadType();
	template <typename T> T ReadToken();
	CVec4f ReadPos();
	void NextLine();
};

template <typename T> 
T CShipLoader::ReadToken()
{
	T out_T;
	inFile >> out_T;
	return out_T;
}

#endif
