/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
Function to start up freebooter game.
Load all relevant data, then populate the arena.
*/

#include "FreeBooter.h"
#include <ctime>
#include "SDL/SDL.h"
#include "GL/gl.h"

int StartFreebooter()
{
	SDL_ShowCursor(0);
	extern CFreebooter FB;
	srand(time(NULL));
	// make player ship
	CShip *player;
	player = new(CShip);

	player->shipType_i = 4;

	CGalaxy *galaxy;
	galaxy = (CGalaxy*)FB.scene;
	
	extern CTextureManager texMan;
	string bck = "data/back.bmp";
	string str = "data/stars.bmp";
	galaxy->backTex_i = texMan.LoadTexture(bck, WIN_BMP);
	galaxy->starsTex_i = texMan.LoadTexture(str, WIN_BMP);
	
	// and for the introduction
	string intro = "data/intro.bmp";
	int introTex_i = texMan.LoadTexture(intro, WIN_BMP);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glEnable(GL_TEXTURE_2D);
	
	glDepthMask(GL_FALSE);
	glColor4f(1.0,1.0,1.0,1.0);
	glLoadIdentity();
	glOrtho(-512,512, 384,-384,0,-10);
	glBindTexture(GL_TEXTURE_2D, texMan.textures[introTex_i].id_ui);
	glBegin(GL_QUADS);
		glTexCoord2f(1, 1); glVertex3f(512,384, 5);
		glTexCoord2f(0, 1); glVertex3f(-512,384, 5);
		glTexCoord2f(0, 0); glVertex3f(-512,-384, 5);
		glTexCoord2f(1, 0); glVertex3f(512,-384, 5);
	glEnd();
	glDisable(GL_TEXTURE_2D);
	

	
	/* Intro sequence (cough cough) */
	Uint8 *keystate;
	keystate = SDL_GetKeyState(NULL);
	
	SDL_GL_SwapBuffers();
	
	int delay = 0;
	while((keystate[SDLK_SPACE] != 1) && (delay < 10000))
	{
		SDL_PumpEvents();
		delay = SDL_GetTicks();
	}
	

	return 0;	
}
