/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Ship.h"
#include "Galaxy.h"

void CShip::DoAI()
{
	if(this->dead_b == true) return;
	SelectMode();							// select a new mode if appropriate
	if(aiMode_i == AIMD_AVOID) Avoid(NULL);	// avoid obstacles in the way
	if(aiMode_i == AIMD_ROAM) Roam();		// roam randomly around galaxy
	if(aiMode_i == AIMD_FIGHT) Fight();		// engage current target
	if(aiMode_i == AIMD_FORMATE) Formate(); // join formation with current target
	// ? More ?
}

void CShip::SelectMode()
{
	// in all cases, check if there is something in the way and avoid hitting it... 
	// this is quite a shabby way of doing it, and I already see its flaws even before
	// implementing it. But let's just see eh?
	// calculate a point some distance infront of this ship
	// in world space.
//*
	extern CFreebooter FB;
	CGalaxy *gal = (CGalaxy*)FB.scene;

	CVec4f face_v4f;
	face_v4f.SetXYZW(0,1,0,0);

	CMatrix4f tfm;
	tfm.SetIdentity();
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
		glLoadIdentity();
//		glTranslatef(-pos_v4f.X(), -pos_v4f.Y(), -pos_v4f.Z());
		glRotatef(rot_v3f.X(), 1, 0, 0);
		glRotatef(rot_v3f.Y(), 0, 1, 0);
		glRotatef(rot_v3f.Z(), 0, 0, 1);
		glGetFloatv(GL_MODELVIEW_MATRIX, tfm.m_af);
	glPopMatrix();
	tfm.Transpose();

	face_v4f = face_v4f.Transform(tfm);

	CVec4f pif = face_v4f + pos_v4f;
	if(aiMode_i != AIMD_AVOID)
	{
		// see if there are any obstacles in the way
		bool clear_b = true;
		int sc_i = 0;
		while((clear_b == true) && (sc_i < gal->ments.Size()))
		{
			CVec4f shipToEnt;
			shipToEnt = gal->ents[gal->ments[sc_i]]->GetPos() - pos_v4f;
			shipToEnt.SetW(0);
			if(shipToEnt.MagSquare() < 300)
			{
				if(gal->ents[gal->ments[sc_i]] != this)
					clear_b = !((CModelEntity*)gal->ents[gal->ments[sc_i]])->BSVectCollision(pos_v4f, pif);
			}
			if(clear_b)sc_i++;
		}
		if(clear_b == false)
		{
			aiPrevMode_i = aiMode_i;
			aiMode_i = AIMD_AVOID;
			aiSubMode_i = 0;
			Avoid((CModelEntity*)gal->ents[gal->ments[sc_i]]);
			
		}
	}//*/
	if(aiMode_i == AIMD_FIGHT)
	{
		if(((abs(X() - target->X()) > 150) &&
			(abs(Y() - target->Y()) > 150)) || ((CShip*)target)->dead_b == true) // stop fighting (range too large || target dead)
		{
			// before roaming, see if an ally is alive that has an index nearer to zero.
			// if so, formate with it. 
			//*
			extern CFreebooter FB;
			CGalaxy *gal = (CGalaxy*)FB.scene;
			int c_i = 0;
			bool newTarget_b = false;
			while((gal->ents[gal->ships[c_i]] != this) && (newTarget_b == false))
			{
				// is this ship an ally?
				CShip *ship = (CShip*) gal->ents[gal->ships[c_i]];
				if((ship->faction_i == this->faction_i) && (ship->dead_b == false))
				{
					this->target = ship;
					newTarget_b = true;
					aiMode_i = AIMD_FORMATE;
				}
				c_i++;
			}
					
			// Otherwise, roam.
			if(newTarget_b == false)
			{
				aiMode_i = AIMD_ROAM;
				GenerateRoute();
			}
			//*/
			aiMode_i = AIMD_ROAM;
			GenerateRoute();
		}

	}
	// if(aiMode_i == AIMD_AVOID);
	else if(aiMode_i == AIMD_FORMATE)
	{
	        this->Formate();
	}
	else // probably roaming or formating
	{
		// before roaming, see if an ally is alive that has an index nearer to zero.
			// if so, formate with it. 
			
			extern CFreebooter FB;
			CGalaxy *gal = (CGalaxy*)FB.scene;
			//*
			int c_i = 0;
			bool newTarget_b = false;
			while((gal->ents[gal->ships[c_i]] != this) && (newTarget_b == false))
			{
				// is this ship an ally?
				CShip *ship = (CShip*) gal->ents[gal->ships[c_i]];
				if((ship->faction_i == this->faction_i) && (ship->dead_b == false))
				{
					this->target = ship;
					newTarget_b = true;
					aiMode_i = AIMD_FORMATE;
				}
				c_i++;
			}
					
			// Otherwise, roam.
			if(newTarget_b == false)
			{
				aiMode_i = AIMD_ROAM;
				GenerateRoute();
			}
			//*/
		{
			if(waypoints.Size() == 0) GenerateRoute();
			aiMode_i = AIMD_ROAM;
		
			// if a ship get's within a certain range, attack it until its range is twice that
			for(int sc_i = 0; sc_i < gal->ships.Size(); sc_i++)
			{
				if((abs(X() - gal->ents[gal->ships[sc_i]]->X()) < 50) &&
					(abs(Y() - gal->ents[gal->ships[sc_i]]->Y()) < 50) &&
					(gal->factions[faction_i]->relations[((CShip*)gal->ents[gal->ships[sc_i]])->faction_i] < 4) &&
					this != gal->ents[gal->ships[sc_i]] )
				{
					this->target = gal->ents[gal->ships[sc_i]];
					aiMode_i = AIMD_FIGHT;
					aiSubMode_i = 0;
				}
			}
		}
	}
}

void CShip::GenerateRoute()
{
	// for now, just one random waypoint
	extern CFreebooter FB;
	CGalaxy *gal = (CGalaxy*) FB.scene;
	waypoints.SetSize(1);
	waypoints[0].SetXYZW(rand()%(int)gal->width_f, rand()%(int)gal->height_f, 0, 1);
}

void CShip::Fight()
{
	// a bad but simple implementation based on the roaming behaviour
	CVec4f posToWay;	// vector to target - can you see the copy and paste... ;P
	posToWay = target->GetPos() - pos_v4f;
	posToWay.SetW(0);
	if(posToWay.Magnitude() < 10) GenerateRoute();

	// turn towards waypoint
	CVec4f faceVector;
	faceVector.SetXYZW(0,1,0,1);
	CMatrix4f tfm;
	tfm.SetIdentity();
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
		glLoadIdentity();
//		glTranslatef(-pos_v4f.X(), -pos_v4f.Y(), -pos_v4f.Z());
		glRotatef(rot_v3f.X(), 1, 0, 0);
		glRotatef(rot_v3f.Y(), 0, 1, 0);
		glRotatef(rot_v3f.Z(), 0, 0, 1);
		glGetFloatv(GL_MODELVIEW_MATRIX, tfm.m_af);
	glPopMatrix();
	tfm.Transpose();
	faceVector = faceVector.Transform(tfm);

	faceVector.SetW(0);
	posToWay.SetW(0);

	float dist = posToWay.MagSquare();

	faceVector.Normalise();
	posToWay.Normalise();

	CVec4f vel;
	vel.SetXYZW(-vel_v4f.X(), -vel_v4f.Y(),-vel_v4f.Z(),0);
	vel.Normalise();
	float degAngle;
	CVec4f decisionVec;
	decisionVec = posToWay.Cross(faceVector);
	float z = decisionVec.Z();
	float cosangle = faceVector.Dot(posToWay);
	float angle = acos(cosangle);
	degAngle = (angle*180) / 3.14;
	if(aiSubMode_i == 0)
	{
		waypoints.Clear();
		if(dist > rand()%4000 + 6000)	// if reasonably far away
		{
			if(z > 0)
				RotateCW();
			if(z < -0)
				RotateCCW();
			if((degAngle < 20) || (degAngle > 340))
			{
				FwdThrust();
				
				// check for line of sight. don't want to shoot a friendly!

				// calculate a point some distance infront of this ship
				// in world space.

				extern CFreebooter FB;
				CGalaxy *gal = (CGalaxy*)FB.scene;

				CVec4f face_v4f;
				face_v4f.SetXYZW(0,1,0,0);

				CMatrix4f tfm;
				tfm.SetIdentity();
				glMatrixMode(GL_MODELVIEW);
				glPushMatrix();
					glLoadIdentity();
			//		glTranslatef(-pos_v4f.X(), -pos_v4f.Y(), -pos_v4f.Z());
					glRotatef(rot_v3f.X(), 1, 0, 0);
					glRotatef(rot_v3f.Y(), 0, 1, 0);
					glRotatef(rot_v3f.Z(), 0, 0, 1);
					glGetFloatv(GL_MODELVIEW_MATRIX, tfm.m_af);
				glPopMatrix();
				tfm.Transpose();

				face_v4f = face_v4f.Transform(tfm);

				CVec4f pif = face_v4f + pos_v4f;

				// see if there are any allied ships in the way
				bool clear_b = true;
				int sc_i = 0;
				while((clear_b == true) && (sc_i < gal->ships.Size()))
				{
					if(((CShip*)gal->ents[gal->ships[sc_i]])->faction_i == this->faction_i)
					{
						clear_b = ((CShip*)gal->ents[gal->ships[sc_i]])->BSVectCollision(this->GetPos(), pif);
					}
					sc_i++;
				}

				if(clear_b)FireGun();
			}
		}
		else if(dist < 400)
		{
			// BACK OFF! YOU'RE TOO CLOSE!!! AHHHH!!!

			if(z > 0)
				RotateCW();
			if(z < -0)
				RotateCCW();
			if((degAngle < 20) || (degAngle > 340))
			{
				RvsThrust();
				// check for line of sight. don't want to shoot a friendly!

				// calculate a point some distance infront of this ship
				// in world space.

				extern CFreebooter FB;
				CGalaxy *gal = (CGalaxy*)FB.scene;

				CVec4f face_v4f;
				face_v4f.SetXYZW(0,1,0,0);

				CMatrix4f tfm;
				tfm.SetIdentity();
				glMatrixMode(GL_MODELVIEW);
				glPushMatrix();
					glLoadIdentity();
			//		glTranslatef(-pos_v4f.X(), -pos_v4f.Y(), -pos_v4f.Z());
					glRotatef(rot_v3f.X(), 1, 0, 0);
					glRotatef(rot_v3f.Y(), 0, 1, 0);
					glRotatef(rot_v3f.Z(), 0, 0, 1);
					glGetFloatv(GL_MODELVIEW_MATRIX, tfm.m_af);
				glPopMatrix();
				tfm.Transpose();

				face_v4f = face_v4f.Transform(tfm);

				CVec4f pif = face_v4f + pos_v4f;

				// see if there are any allied ships in the way
				bool clear_b = true;
				int sc_i = 0;
				while((clear_b == true) && (sc_i < gal->ships.Size()))
				{
					if(((CShip*)gal->ents[gal->ships[sc_i]])->faction_i == this->faction_i)
					{
						clear_b = ((CShip*)gal->ents[gal->ships[sc_i]])->BSVectCollision(this->GetPos(), pif);
					}
					sc_i++;
				}

				if(clear_b)FireGun();
			}	
		}
		else 
		{
			aiSubMode_i = 1;
			waypoints.Clear();
			glMatrixMode(GL_MODELVIEW);
			glPushMatrix();
				glLoadIdentity();
		//		glTranslatef(-pos_v4f.X(), -pos_v4f.Y(), -pos_v4f.Z());
				glRotatef(target->XRot(), 1, 0, 0);
				glRotatef(target->YRot(), 0, 1, 0);
				glRotatef(target->ZRot(), 0, 0, 1);
				glGetFloatv(GL_MODELVIEW_MATRIX, tfm.m_af);
			glPopMatrix();
			tfm.Transpose();
			CVec4f targsSix;
			int r = rand()%50;
			if(r > 25)targsSix.SetXYZW((float) -(rand()%50+50),(float)-(rand()%50+100),0,0);
			else targsSix.SetXYZW((float)(rand()%50+50),(float)-(rand()%50+100),0,0);
			targsSix = targsSix.Transform(tfm);
			targsSix = targsSix + target->GetPos();
			waypoints.AddToEnd(targsSix);
			aiStartTime_i == SDL_GetTicks();
		}
	}
	if(aiSubMode_i == 1) // otherwise fly straight past target until reasonably far away
	{
		
		
		Roam();
		if((degAngle < 20) || (degAngle > 340))
			{
				FireGun();
			}

		if(dist > 8000) aiSubMode_i = 0;
		if((SDL_GetTicks() - aiStartTime_i > 2000) && ((degAngle > 90) && (degAngle < 270))) 
			aiSubMode_i = 0;
		
	}


}

int CShip::Roam()
{
	CVec4f posToWay;	// vector to waypoint
	if(waypoints.Size() < 1)
	{
		GenerateRoute();
	}
	posToWay = waypoints[waypoints.Size()-1] - pos_v4f;
	posToWay.SetW(0);
	if(posToWay.Magnitude() < 10) 
	{
		if(waypoints.Size() <= 1) waypoints.Clear();
		else waypoints.SetSize(waypoints.Size() - 1);
	}

	// turn towards waypoint
	CVec4f faceVector;
	faceVector.SetXYZW(0,1,0,1);
	CMatrix4f tfm;
	tfm.SetIdentity();
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
		glLoadIdentity();
//		glTranslatef(-pos_v4f.X(), -pos_v4f.Y(), -pos_v4f.Z());
		glRotatef(rot_v3f.X(), 1, 0, 0);
		glRotatef(rot_v3f.Y(), 0, 1, 0);
		glRotatef(rot_v3f.Z(), 0, 0, 1);
		glGetFloatv(GL_MODELVIEW_MATRIX, tfm.m_af);
	glPopMatrix();
	tfm.Transpose();
	faceVector = faceVector.Transform(tfm);

	faceVector.SetW(0);
	posToWay.SetW(0);
	faceVector.Normalise();
	posToWay.Normalise();

	CVec4f vel;
	vel.SetXYZW(-vel_v4f.X(), -vel_v4f.Y(),-vel_v4f.Z(),0);
	vel.Normalise();
	float degAngle;
	extern CFreebooter FB;
	CGalaxy *gal = (CGalaxy*)FB.scene;
	if(vel_v4f.Magnitude() < (0.2 * gal->shipTypes[this->shipType_i]->fwdThrustPow_f * 50))
	{
		CVec4f decisionVec;
		decisionVec = posToWay.Cross(faceVector);
		float z = decisionVec.Z();
		float cosangle = faceVector.Dot(posToWay);
		float angle = acos(cosangle);
		
		degAngle = (angle*180) / 3.14;
		if(z > 0)
			RotateCW();
		if(z < -0)
			RotateCCW();
		if((degAngle < 20) || (degAngle > 340))
		{
			FwdThrust();
		}
	}
	else
	{	
		CVec4f decisionVec;
		decisionVec = posToWay.Cross(faceVector-vel);
		float z = decisionVec.Z();
		if(z > 0)
			RotateCW();
		if(z < 0)
			RotateCCW();

		float cosangle = posToWay.Dot(faceVector);
		float angle = acos(cosangle);
		degAngle = (angle*180) / 3.14;
			FwdThrust();
		
	}
	return degAngle;
	

}

// avoid the given entity
void CShip::Avoid(CModelEntity *in_Obstacle)
{

	// there is an object in our way.
	// generate some suitable waypoint to go around the object, then return to previous
	// ai mode.
	if((aiSubMode_i == 0) && (in_Obstacle != NULL)) // first time through loop
	{
		// get obstacle coords in local space
		CMatrix4f tfm, invTfm;
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
			glLoadIdentity();
			glTranslatef(pos_v4f.X(), pos_v4f.Y(), pos_v4f.Z());
			glRotatef(XRot(), 1, 0, 0);
			glRotatef(YRot(), 0, 1, 0);
			glRotatef(ZRot(), 0, 0, 1);
			glGetFloatv(GL_MODELVIEW_MATRIX, tfm.m_af);
		glPopMatrix();
		
		tfm.Transpose();	
		invTfm = tfm;		
		invTfm.Invert();	
		

		CVec4f obsLoc = in_Obstacle->GetPos();
		obsLoc = obsLoc.Transform(invTfm);

		CVec4f avoid;
		avoid.SetXYZW(in_Obstacle->boundSphRadius_f + (this->boundSphRadius_f *1.5), 0, 0, 0);
		CVec4f newWyPntLoc = obsLoc + avoid;

		CVec4f newWyPnt;
		newWyPnt = newWyPntLoc.Transform(tfm);
		newWyPnt.SetZ(0);
		waypoints.AddToEnd(newWyPnt);
		aiSubMode_i = 1;
	}

	else
	{
		// if the ship reaches the avoidance waypoint, that waypoint will be removed.

		int nwp = waypoints.Size();
		Roam();
		if((nwp - waypoints.Size()) > 0)
		{
			aiMode_i = aiPrevMode_i;
			aiPrevMode_i = AIMD_AVOID;
		}
	}


	
}

void CShip::Formate()
{
	if(waypoints.Size() > 0)
        waypoints.Clear();
	CVec4f nwp;
	nwp.SetXYZW(target->X(), target->Y(), target->Z(), 1);
	waypoints.AddToEnd(nwp);
	Roam();
	if(((CShip*)target)->aiMode_i == AIMD_FIGHT)
	{
		target = ((CShip*)target)->target;
		aiMode_i = AIMD_FIGHT;
		aiSubMode_i = 0;
	}
}
