/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Camera.h"

CCamera::CCamera(void)
{
}

CCamera::~CCamera(void)
{
}

// Set the up vector
void CCamera::SetUp(float in_X_f, float in_Y_f, float in_Z_f)
{
	up_v4f.SetXYZW(in_X_f, in_Y_f, in_Z_f, 0);
	isLockedToTarget_b = false;
}
void CCamera::SetUp(CVec4f in_v4f)
{
	up_v4f = in_v4f;
	isLockedToTarget_b = false;
}
void CCamera::SetUp(CVec3f in_v3f)
{
	up_v4f.SetXYZW(in_v3f.X(), in_v3f.Y(), in_v3f.Z(), 0);
	isLockedToTarget_b = false;
}

// Set the facing vector
void CCamera::SetFace(float in_X_f, float in_Y_f, float in_Z_f)
{
	face_v4f.SetXYZW(in_X_f, in_Y_f, in_Z_f, 0);
	isLockedToTarget_b = false;
}
void CCamera::SetFace(CVec4f in_v4f)
{
	face_v4f = in_v4f;
	isLockedToTarget_b = false;
}
void CCamera::SetFace(CVec3f in_v3f)
{
	face_v4f.SetXYZW(in_v3f.X(), in_v3f.Y(), in_v3f.Z(), 0);
	isLockedToTarget_b = false;
}

// Set the position
void CCamera::SetPos(float in_X_f, float in_Y_f, float in_Z_f)
{
	pos_v4f.SetXYZW(in_X_f, in_Y_f, in_Z_f, 1);
	isLockedToTarget_b = false;
}
void CCamera::SetPos(CVec4f in_v4f)
{
	pos_v4f = in_v4f;
	isLockedToTarget_b = false;
}
void CCamera::SetPos(CVec3f in_v3f)
{
	pos_v4f.SetXYZW(in_v3f.X(), in_v3f.Y(), in_v3f.Z(), 1);
	isLockedToTarget_b = false;
}


// return the up vector
CVec4f CCamera::GetUp(void)
{
	return up_v4f;
}
// return the facing vector
CVec4f CCamera::GetFace(void)
{
	return face_v4f;
}
// return the position
CVec4f CCamera::GetPos(void)
{
	return pos_v4f;
}

// Lock the camera view to an entity, indexed in the scene by in_Ent_i
void CCamera::LockToTarget(int in_Ent_i, float in_Dist_f)
{
	
}
