/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DAZZLE_CAMERA
#define DAZZLE_CAMERA

#include "Vec4f.h"
#include "Vec3f.h"

class CCamera
{
protected:
	CVec4f up_v4f;
	CVec4f face_v4f;
	CVec4f pos_v4f;

	bool isLockedToTarget_b;
public:
	CCamera(void);
	~CCamera(void);

	// Set the up vector
	void SetUp(float in_X_f, float in_Y_f, float in_Z_f);
	void SetUp(CVec3f in_v3f);
	void SetUp(CVec4f in_v4f);

	// Set the facing vector
	void SetFace(float in_X_f, float in_Y_f, float in_Z_f);
	void SetFace(CVec3f in_v3f);
	void SetFace(CVec4f in_v4f);

	// Set Position
	void SetPos(float in_X_f, float in_Y_f, float in_Z_f);
	void SetPos(CVec3f in_v3f);
	void SetPos(CVec4f in_v4f);

	// return the up vector
	CVec4f GetUp(void);
	// return the facing vector
	CVec4f GetFace(void);
	// return the position
	CVec4f GetPos(void);

	// Lock the camera view to an entity, indexed in the scene by in_Ent_i
	void LockToTarget(int in_Ent_i, float in_Dist_f);
};

#endif