/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DAZZLE_COLLISION
#define DAZZLE_COLLISION

#include "Matlib.h"
#include "DynArray.h"
#include "Entity.h"
// set of useful structures for recording collisions.
struct SMeshCollision
{
	int    face_i;				// face collided with
	CVec4f ip_v4f;				// collision point in mesh space
	float  ip_f;				// collision point as a scalar...
	CVec4f rad_v4f;				// ... on this radius
};
struct SEntityCollision
{
	CEntity *entity_p;			// pointer to (model)entity
	CDynArray<int> subent_ai;	// sub entity collision is with (if it matters)
								// needs recursion for use.
								// {1, 3, 4} will mean collision is with fourth subent, of the
								// third subent of the first subent of the entity. doubt it'll
								// ever go quite that deep.
	SMeshCollision mCol;		// The mesh collision
};

#endif