/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Dazzle.h"


void CDazzleApp::SetGfx(int in_ResX, int in_ResY, int in_CD, bool in_FS)
{
	resx = in_ResX;
	resy = in_ResY;
	colourDepth = in_CD;
	useFullscreen_b = in_FS;
	this->resIsSet_b = true;
}

int CDazzleApp::Init()
{
	// open log file
	appLog.open("log.txt");

	// Initialise OpenGL and SDL
	if(SDL_Init(SDL_INIT_VIDEO) != 0)
    {
        appLog << "Unable to initialise SDL: " << SDL_GetError() << endl;
		cout << "Unable to initialise SDL: " << SDL_GetError() << endl;
        appLog.close();
        return -1;
    }   
    atexit(SDL_Quit);

	/* configure OpenGL attributes  - to be set up by application?? */
    SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
    SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
    SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 6);
    SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);
    SDL_GL_SetAttribute(SDL_GL_STENCIL_SIZE, 8);

	/* Open OpenGL context for rendering */
	if(this->resIsSet_b == false)
	{
		appLog << "Graphics options not set, resorting to defaults, 640 x 640 x 16" << endl;
		cout  << "Graphics options not set, resorting to defaults, 640 x 640 x 16" << endl;
		resx = 640;
		resy = 640;
		colourDepth = 32;
	}
	if(useFullscreen_b == true) screen = SDL_SetVideoMode(resx, resy, colourDepth, SDL_OPENGL | SDL_FULLSCREEN);
	else screen = SDL_SetVideoMode(resx, resy, colourDepth, SDL_OPENGL);
	if(screen == NULL)
    {
        appLog << "Unable to initialise video mode: " << SDL_GetError() << endl;
		cout << "Unable to initialise video mode: " << SDL_GetError() << endl;
        appLog.close();
        return -1;
    }
	
	int sb;
	glGetIntegerv(GL_STENCIL_BITS, &sb);
	appLog << "stencil bits : " << sb;

	return 0;
}

int CDazzleApp::CreateScene()
{
	this->scene = new(CScene);
	return 0;
}
