/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DAZZLE_HEADER
#define DAZZLE_HEADER

#include <string>
#include <fstream>
#include <iostream>
using namespace std;

#include "Entity.h"
#include "Face.h"
#include "Mesh.h"
#include "ModelManager.h"
#include "ModelEntity.h"
#include "TextureManager.h"
#include "Scene.h"
#include "TerrainGenerator.h"
#include "SimpleParticle.h"
#include "SimpleParticleGenerator.h"
#include "TextBox.h"

// an aplication management class for any projects that intend to make use of Dazzle
class CDazzleApp
{
public:
	CDazzleApp(void){};
	~CDazzleApp(void){};

	// Pointer to a scene for the application. The application should modify the scene
	// class to a more relevant version for its purposes.
	CScene *scene;

	// log file
	ofstream appLog;

	// SDL surface for the rendering context
	SDL_Surface *screen;

	// Initialisation functions
	void SetGfx(int in_ResX, int in_ResY, int in_CD, bool in_FS);
	virtual int Init();

	// function to create an empty scene. Application should modify this to create
	// an inherited scene class appropriate to the application's purposes
	virtual int CreateScene();

protected:

	// application screen resolution information
	int resx;
	int resy;
	int colourDepth;
	bool useFullscreen_b;
	bool resIsSet_b;	// has the above info been set??
	
};

#endif