/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MATLIB_MATRIX3F
#define MATLIB_MATRIX3F
/************************************************************************
 *						3D matrix class - Matlib						*
 *																		*
 *						    Murray Evans 2003							*
 ************************************************************************/
#include <cmath>
#include <string>
#include "Cast.h"	// a function that casts using a string stream

class CMatrix3f
{
public:
	// constructors
	CMatrix3f(void);
	CMatrix3f(float in_00, float in_10, float in_20,
			  float in_01, float in_11, float in_21,
			  float in_02, float in_12, float in_22);
	CMatrix3f(float in_M_af[9]);
	// CMatrix3f(CMatrix4f in_m4f);
	~CMatrix3f(void);

	// data
	float m_af[9];

	// accessors

	// modifiers
	void SetIdentity();

	// arithmetic
	CMatrix3f PreMult(CMatrix3f in_m3f);	// in_m3f * this
	CMatrix3f PostMult(CMatrix3f in_m3f);   // this * in_m3f
	void      Invert();						// invert this matrix
	void	  Transpose();					// transpose this matrix

	// output as a nice neat string
	string WriteOut();

	// overloaded operators
	CMatrix3f operator+(CMatrix3f& in_m3f);
	CMatrix3f operator-(CMatrix3f& in_m3f);

};

#endif

