/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MATLIB_MATRIX4F
#define MATLIB_MATRIX4F
/************************************************************************
 *					3D Homogeneous matrix class - Matlib				*
 *																		*
 *						    Murray Evans 2003							*
 ************************************************************************/
#include <string>
#include <cmath>
#include "Cast.h"
using namespace std;


class CMatrix4f
{
public:
	// constructors
	CMatrix4f(void);
	CMatrix4f(float in_00, float in_10, float in_20, float in_30,
			  float in_01, float in_11, float in_21, float in_31,
			  float in_02, float in_12, float in_22, float in_32,
			  float in_03, float in_13, float in_23, float in_33);
	CMatrix4f(float in_M_af[16]);
	// CMatrix4f(CMatrix4f in_m4f);
	~CMatrix4f(void);

	// data
	float m_af[16];

	// accessors

	// modifiers
	void SetIdentity();
	

	// arithmetic
	CMatrix4f PreMult(CMatrix4f in_m4f);	// in_m4f * this
	CMatrix4f PostMult(CMatrix4f in_m4f);   // this * in_m4f
	void      Invert();						// invert this matrix
	void	  Transpose();					// transpose this matrix

	// output as a nice neat string
	string WriteOut();

	// overloaded operators
	CMatrix4f operator+(CMatrix4f& in_m4f);
	CMatrix4f operator-(CMatrix4f& in_m4f);
};

#endif
