/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DAZZLE_MODELMAN
#define DAZZLE_MODELMAN

#include "Mesh.h"
#include "DynArray.h"
#include <string>
#include <fstream>
using namespace std;

#define OBJ 0

class CModelManager
{
public:
	CModelManager(void);
	~CModelManager(void);
	CDynArray<CMesh*> meshes;
	// Load a mesh from the file in_Filename_s, of filetype defined by one of the above constants. Return index of loaded file.
	int LoadMesh(string in_Filename_s, int in_Filetype_i);
	// Loads an Alias|Wavefront .obj file
	int LoadOBJ(string in_Filename_s);
	// Add a mesh to the library, returning index
	int AddMesh(CMesh *in_Mesh);
	// Clear all loaded meshes
	void ClearLibrary(void);
	// Get a pointer to the specified mesh
	CMesh* GetMesh(int in_Index_i);
};


#endif
