/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Scene.h"
/********************************************************************
 *								 Dazzle								*
 *							Basic Scene Class						*
 *																	*
 *							   Murray Evans							*
 ********************************************************************/

CScene::CScene(void)
{
	shadowsEnabled_b = false;
	lightsEnabled_b = false;
	texturesEnabled_b = false;
}

CScene::~CScene(void)
{
	for(int ec_i = 0; ec_i < ents.Size(); ec_i++)
	{
		ents[ec_i]->PrepareForDestruction();
//		if(ents[ec_i] != NULL) delete(ents[ec_i]);
	}
	ents.Clear();
}

// Add an entity to the scene. Return the index of the entity once it has been added
int CScene::AddEntity(CEntity* in_Entity_p)
{
	ents.AddToEnd(in_Entity_p);
	return ents.Size() -1;
}
int CScene::AddLight(CEntity* in_Entity_p)
{
	ents.AddToEnd(in_Entity_p);
	lights.AddToEnd(ents.Size()-1);
	return ents.Size()-1;
}
int CScene::AddMent(CEntity* in_Entity_p)
{
	int index;
	index = AddEntity(in_Entity_p);
	ments.AddToEnd(index);
	return index;
}

// Load the scene from a scenefile, which details all entities that need be loaded, and anything special about them.
int CScene::LoadFromFile(string in_Filename_s)
{
	return 0;
}

// Update the scene
void CScene::Update(void)
{
}
