/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "SimpleParticle.h"
#include "GL/gl.h"
#include "Dazzle.h"

CSimpleParticle::CSimpleParticle(void)
{
	this->boundSphRadius_f = 0.75;
	this->hasBoundSph_b = true;
	size_f = 0.75;
	this->hasTexture_b = false;
	
}

CSimpleParticle::~CSimpleParticle(void)
{
}

void CSimpleParticle::Render()
{
   if(this->life > 0)
   {
		glPushMatrix();
		glDisable(GL_CULL_FACE);
		glDisable(GL_LIGHTING);
		if(hasTexture_b == false) glDisable(GL_TEXTURE_2D);
		else
		{
			extern CTextureManager texMan;
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, texMan.textures[tex_i].id_ui);
		}

		glTranslatef(pos_v4f.X(), pos_v4f.Y(), pos_v4f.Z());
		//glRotatef(rot_v3f.X(), 1, 0, 0);
        //glRotatef(rot_v3f.Y(), 0, 1, 0);
        //glRotatef(rot_v3f.Z(), 0, 0, 1);

		glEnable(GL_BLEND);
		//glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
		glDepthMask(GL_FALSE);
		glColor4f((GLfloat)r_f,(GLfloat) g_f,(GLfloat) b_f,(GLfloat) a_f);
		glBegin(GL_QUADS);
			glNormal3f(0.0,0.0,1.0);
			glTexCoord2f(0.0,0.0); glVertex3f(-size_f,-size_f, 0.0);
			glTexCoord2f(1.0,0.0); glVertex3f( size_f,-size_f, 0.0);
			glTexCoord2f(1.0,1.0); glVertex3f( size_f, size_f, 0.0);
			glTexCoord2f(0.0,1.0); glVertex3f(-size_f, size_f, 0.0);
			/*glNormal3f(0,1,0);
			glTexCoord2i(0,0); glVertex3f(-size_f,0, -size_f);
			glTexCoord2i(1,0); glVertex3f( size_f,0, -size_f);
			glTexCoord2i(1,1); glVertex3f( size_f,0,  size_f);
			glTexCoord2i(0,1); glVertex3f(-size_f,0,  size_f);*/
		glEnd();
		/*float cols[4];
		glGetFloatv(GL_CURRENT_COLOR, cols);
		fprintf(stdout, "%f %f %f %f \n", cols[0], cols[1], cols[2], cols[3]);*/


		if(hasTexture_b == true)
		{
				glDisable(GL_TEXTURE_2D);
		}
		glDepthMask(GL_TRUE);
		glDisable(GL_BLEND);
		glEnable(GL_LIGHTING);
		glEnable(GL_CULL_FACE);
		glPopMatrix();
  }
}

void CSimpleParticle::Update(void)
{
	SetRotation(0,0,ZRot()+17);
	pos_v4f = vel_v4f + pos_v4f;
	pos_v4f.SetW(1);
	if(life > 0)life--;
}

void CSimpleParticle::SetColour(float in_R, float in_G, float in_B, float in_A)
{
	r_f = in_R;
	g_f = in_G;
	b_f = in_B;
	a_f = in_A;
}


