/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "SimpleParticleGenerator.h"
#include <iostream>
using namespace std;

CSimpleParticleGenerator::CSimpleParticleGenerator(void)
{
}

CSimpleParticleGenerator::~CSimpleParticleGenerator(void)
{
}

void CSimpleParticleGenerator::Render()
{
	for(unsigned int pc_i = 0; pc_i < particles.size(); pc_i++)
	{
		particles[pc_i]->Render();
	}
}

void CSimpleParticleGenerator::Update()
{
	// clean up dead particles, update undead particles
	//int loopLimit = particles.size();
	//int pc_i = 0;
	//while(pc_i < loopLimit)
	//{
	//	if(particles[pc_i]->life <= 0)
	//	{
	//		// remove dead particle
	//		vector<CSimpleParticle*>::iterator iter;
	//		if(pc_i > loopLimit)
	//		{
	//			cout << "It can go wrong!!" << endl;
	//			exit(1);
	//		}
	//		delete(particles[pc_i]);
	//		iter = particles.begin();
	//		int c_i = 0;
	//		while(c_i < pc_i) {iter++; c_i++;}
	//		particles.erase(iter);
	//		loopLimit--;
	//		pc_i--;
	//	}
	//	else
	//	{
	//		particles[pc_i]->Update();
	//	}
	//	pc_i++;
	//}
	
	vector<CSimpleParticle*>::iterator iter;
	if(particles.size() > 0)
	{
		for(iter = particles.end()-1; iter >= particles.begin(); iter--)
		{
			if((*iter)->life <= 0)
			{
				delete(*iter);
				particles.erase(iter);
			}
			else
			{
				(*iter)->Update();
			}
		}
	}
}

void CSimpleParticleGenerator::AddParticle(CSimpleParticle *in_Spart)	// colour
{
	particles.push_back(in_Spart);
	
}

void CSimpleParticleGenerator::CleanParticles()
{
	particles.clear();
}
