/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _DAZZLE_TERA_GEN_
#define _DAZZLE_TERA_GEN_
/********************************************************************
 *								 Dazzle								*
 *					    Terrain generator class						*
 *																	*
 *							   Murray Evans							*
 ********************************************************************/

#include "Entity.h"
#include "ModelEntity.h"
#include "Mesh.h"
#include "SDL/SDL.h"
#include <string>
using namespace std;
// Generate a model entity, where the model is generated from a height map
class CTerrainGenerator
{
public:
	CTerrainGenerator(void);
	~CTerrainGenerator(void);

	// main function call to generate terrain. Pass in two filenames corresponding
	// to a height map and a texture map, then the desired size of the mesh as 
	// width (x), heigh(y) and depth(z), then the number of divisions along the width
	// and the depth.
	// height map is greyscale 0-255, so black values are the lowest, and white the 
	// highest
	CModelEntity	GenerateFromGrey(string in_HMapFilename_s, string in_TMapFilename_s,
					float in_MWidth_i, int in_MHeight_i, int in_MDepth_i,
					int in_DivisionsW_i, int in_DivisionsD_i);
protected:
	// function to create a blank flat triangle (?) mesh of the given proportions
	void			GenerateMesh(CMesh *mesh, int in_MWidth_i, int in_MHeight_i, int in_MDepth_i,
								 int in_DivisionsW_i, int in_DivisionsD_i);
	// function to reposition vertices to correspond to height map
	void			SetHeights(CMesh *in_Mesh, SDL_Surface *in_hmap, int in_MHeight_i);
};
#endif
