/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "TextBox.h"
#include "GL/gl.h"
#include "SDL/SDL.h"


CTextBox::CTextBox(void)
{
	font = new FTGLTextureFont("data/Artlookin/Artlookin-Regular.ttf");
	font->FaceSize(10);
}

CTextBox::~CTextBox(void)
{
}

void CTextBox::Render()
{
	// get an ortho viewing matrix
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glDisable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDepthMask(GL_FALSE);
	GLdouble size;
	GLdouble aspect;
	// temporary hack!!
	aspect = (GLdouble) 1024/ (GLdouble)768;
	// Use the whole window.
	glViewport(0, 0, 1024, 768);
	// We are going to do some 2-D orthographic drawing.
	size = (GLdouble)((1024 >= 768) ? 1024 : 768);
	if (1024 <= 768) 
	{
		aspect = (GLdouble)768/(GLdouble)1024;
		glOrtho(0, size, 0, size*aspect, -100000.0, 100000.0);
    }
    else
	{
        aspect = (GLdouble)768/(GLdouble)1024;
		glOrtho(0, size*aspect, 0, size,-100000.0, 100000.0);
	}
	glTranslatef(pos_v4f.X(), pos_v4f.Y(), 0);
	glColor4f(1,1,1,1);
	font->Render(text.c_str());

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
}

void CTextBox::Update()
{
}

void CTextBox::RenderText(float in_X, float in_Y, string in_Text_s)
{
	SetPos(in_X, in_Y, 0);
	text = in_Text_s;
	Render();
}
// render with a background
void CTextBox::RenderBG(float in_X, float in_Y, float r, float g, float b, float width)
{
	SetPos(in_X, in_Y, 0);
	
	// get an ortho viewing matrix
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDepthMask(GL_FALSE);
	GLdouble size;
	GLdouble aspect;
	// temporary hack!!
	aspect = (GLdouble) 1024/ (GLdouble)768;
	// Use the whole window.
	glViewport(0, 0, 1024, 768);
	// We are going to do some 2-D orthographic drawing.
	size = (GLdouble)((1024 >= 768) ? 1024 : 768);
	if (1024 <= 768) 
	{
		aspect = (GLdouble)768/(GLdouble)1024;
		glOrtho(0, size, 0, size*aspect, -100000.0, 100000.0);
    }
    else
	{
        aspect = (GLdouble)768/(GLdouble)1024;
		glOrtho(0, size*aspect, 0, size,-100000.0, 100000.0);
	}
	glTranslatef(pos_v4f.X(), pos_v4f.Y()-4, 0);
	// background
	glColor4f(r,g,b,1);
	glBegin(GL_QUADS);
		glVertex3f(0,0,0);
		glVertex3f(width, 0, 0);
		glVertex3f(width, font->FaceSize(), 0);
		glVertex3f(0,  font->FaceSize(), 0);
	glEnd();

	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
}

