/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DAZZLE_TEXMAN
#define DAZZLE_TEXMAN
/********************************************************************
 *		     Dazzle					    *
 *		Texture manager					    *
 *								    *
 *		  Murray Evans  				    *
 ********************************************************************/
#include <fstream>
#include <string>
#include <vector>
#include "GL/gl.h"
#include "GL/glu.h"
#include "SDL/SDL.h"
using namespace std;

#define WIN_BMP 0

struct STexture
{
	GLuint id_ui;
	string filename_s;		// file texture was loaded from
};

class CTextureManager
{
public:
	CTextureManager(void);
	~CTextureManager(void);

	vector<STexture> textures;

	// Load a texture from a file in_Filename_s. Filetype is one of the above defined constants
	int LoadTexture(string in_Filename_s, int in_FileType_i);
	// Delete all stored texture data
	void ClearLibrary(void);

protected:
	SDL_Surface *LoadImage(string in_Filename_s, int in_Filetype_i);
	void CreateTexture(STexture *out_tex, SDL_Surface *in_surf, int in_Filetype_i);
};

#endif
