/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MATLIB_VEC2F
#define MATLIB_VEC2F

/************************************************************************
 *						2D vector class - Matlib						*
 *																		*
 *						    Murray Evans 2003							*
 ************************************************************************/



#include <cmath>
#include <string>
#include "Cast.h"	// a function that casts using a string stream
using namespace std;

class CVec2f
{
public:
	// constructors
	CVec2f(void);
	CVec2f(float in_X, float in_Y);
	~CVec2f(void);

	// data storage
	float xy_af[2];

	// accessor
	float X();		// return x
	float Y();		// return y

	// setting
	void SetX(float in_X);
	void SetY(float in_Y);
	void SetXY(float in_X, float in_Y);

	// maths functions
	float  Dot(CVec2f in_Vec);			// dot product of this vector with in_Vec
//	void   Transform(CMatrix2f in_Mat);	// transform by the square matrix in_Mat
	void   Normalise();					// Normalise the vector (set magnitude to 1)
	float  Magnitude();					// Return length/magnitude of vector
	float  MagSquare();					// Return magnitude squared (faster than magnitude)

	// output as string
	string WriteOut();

	// Overloaded operators
	CVec2f operator+(int in_i);
	CVec2f operator+(CVec2f in_v2f);
	CVec2f operator-(int in_i);
	CVec2f operator-(CVec2f in_v2f);
	CVec2f operator*(int in_i);
	CVec2f operator/(int in_i);

};

#endif
