/***************************************************************************
 *   Copyright (C) 2004 by Murray Evans                                    *
 *   m.evans@rdg.ac.uk                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FREEBOOTER_STRUCTS
#define FREEBOOTER_STRUCTS

struct SCargoType
{
	string name; // e.g. refined ore, computer parts
	int type_i;	 // one of AGRIC, RAWMAT, LUXURY, FUEL, REFINED, TECH.
	float  standardValue_f;	// standard value per tonne.
	float  maxDeviation_f;	// maximum that value can be shifted from normal
	int    volumePerTonne_i;// how much space will a tonne take up?
};

struct SGunType
{
	string name;
	bool hasTexturedParticle_b;	// does it produce a textured particle?
	int tex_i;					// if it does, need this.
	float r_f, g_f, b_f, a_f;	// what colour is that particle based on?
	int damage_i;				// how much damage does one particle cause?
	float speed_f;				// how fast do the paricles move?
	float chargeRate_f;			// how fast does it recharge?
	float chargeCost_f;			// how much charge does a single shot use up?
	float maxCharge_f;			// what is the maximum charge the gun can store?
	float minCharge_f;			// what is the minumum charge (allows burst firing weapons)
	bool  isBurst_b;			// gun waits for minimum charge, then discharges all very fast
	int   fireRate_i;			// how fast can the gun fire?
	int   absorbtion_i;			// percentage of shot damage absorbed by shields.
	float partSize_f;			// size of bullet sprite
};

struct SShipType
{
	CMesh *mesh_p;	// pointer to the mesh in the model manager (ignore ship entity's pointer)
	// index of texture in texture manager. First texture is for general use.
	// Faction 0 will use texture 1, faction 1 will use texture 2 etc...
	// if there is no corresponding texture, factions will use texture 0
	CDynArray<int>  tex_i;	
	string name;
	float  mass_f;  // mass of ship
	float  fwdThrustPow_f; // standard forward thruster power
	float  rvsTrustPow_f;  // standard reverse thruster power
	CDynArray<CVec4f> thrPositions;	// where to the thruster-trails emanate from?
	// ;p any gun class can be fitted, if you can lift the weight
	CDynArray<CVec4f> gunPositions;	// where do the guns fire from on the mesh?
	float  rotationSpeed_f;// angle rotated through on an update where ship turns
	int	   maxHullHealth_i;// number of hitpoints
	int	   maxCargoMass_i; // maximum mass of cargo that can be lifted by the tonne
	int    maxCargoVol_i;  // maximum volume of cargo that can be lifted by kilolitre
	int    value_i;		   // cost to buy this ship new	
};

struct SFaction
{
	string name;

	// this array has an integer for all other factions in the galaxy
	// in the range 1 - 10. 1 = kill on sight, 10 = ally so help out
	CDynArray<int> relations;
};
#endif